'******************************************************
'Hidenori Shoji (TOKAI OPTICAL CO., LTD)
'Ver.07:2006/5/16 Calc_Tact07.bas
'
'Function:
'Calculation of production tact time
'Output ot the "Report Generator"
'******************************************************
Option Explicit
DefInt i-N
DefSng A-H, O-Z

'----- Global variables -----
Const MTLS = 5 'ޗ
Const FNAME_INI As String = "\T_Ini_Calc_Tact.fbi" 'Initialization file name
Const FEND As String = "m01"     'Extension of all parameters file
Const FEND_MTL As String = "m04" 'Extension of material file
Const FEND_MCH As String = "m05" 'Extension of machine file

'----- Structure -----
'Thin film material data
Type Material
	sym As String
	mtl As String
	pre_heat As Single
	tool As Single
	rate As Single
	tact As Single
	thick As Single
End Type

'Machine data
Type MachineData
	pump As Single
	pre_pro As Single
	com As Single
	post_pro As Single
	M(MTLS) As Material
	tact As Single
	thick As Single
End Type
Dim MD As MachineData

Dim nLay%, q!(), qt$(), qd$() 'Design save

Sub Main
	Dim PhysUnit As String

	PhysUnit=DesignPhysUnit

	DesignConvert 1, "N"

	'Get design information
    GetLayers nLay, q(), qt(), qd()

	'Display of machine data dialog
	DlgMachine

	DesignConvert 1, PhysUnit
	DesignConvert 2

End Sub

'Display of machine data dialog
Sub DlgMachine
	Dim l As Integer

	Begin Dialog UserDialog 720,336,"Calculate Tact Time",.DlgMachineFunc ' %GRID:10,7,1,1
		'All Parameters
		GroupBox 10,0,120,70,"All Parameters",.GroupBox2
		PushButton 20,14,100,21,"&Load",.Load_PB
		PushButton 20,42,100,21,"Sa&ve as ...",.Save_PB
		'Machine Parameters
		GroupBox 170,0,540,91,"Coater Parameters",.GroupBox5
		PushButton 180,14,90,21,"Load",.LoadMch_PB
		PushButton 280,14,90,21,"Save as ...",.SaveMch_PB
		Text 260,49,90,14,"P&umping[min]",.Text1,1
		TextBox 360,42,90,21,.Pump_TB
		Text 480,49,120,14,"* Pr&e-process[min]",.Text2,1
		TextBox 610,42,90,21,.Preprocess_TB
		Text 180,70,170,14,"C&omunication(1layer)[min]",.Text3,1
		TextBox 360,63,90,21,.Com_TB
		Text 480,70,120,14,"* P&ost-process[min]",.Text10,1
		TextBox 610,63,90,21,.Postprocess_TB

		'Material
		Text 110,119,60,14,"*M&aterial",.Text8,2
		TextBox 100,133,80,21,.Mtl1_TB
		TextBox 100,154,80,21,.Mtl2_TB
		TextBox 100,175,80,21,.Mtl3_TB
		TextBox 100,196,80,21,.Mtl4_TB
		TextBox 100,217,80,21,.Mtl5_TB

		'Symbol
		Text 190,119,40,14,"S&ym",.Text7,2
		TextBox 190,133,40,21,.Sym1_TB
		TextBox 190,154,40,21,.Sym2_TB
		TextBox 190,175,40,21,.Sym3_TB
		TextBox 190,196,40,21,.Sym4_TB
		TextBox 190,217,40,21,.Sym5_TB

		'Premelt
		Text 240,119,90,14,"Pre-&melt[sec]",.Text9
		TextBox 240,133,90,21,.Heat1_TB
		TextBox 240,154,90,21,.Heat2_TB
		TextBox 240,175,90,21,.Heat3_TB
		TextBox 240,196,90,21,.Heat4_TB
		TextBox 240,217,90,21,.Heat5_TB

		'Tooling
		Text 330,119,70,14,"&Tooling",.Tooling_TB,2
		TextBox 330,133,70,21,.Tool1_TB
		TextBox 330,154,70,21,.Tool2_TB
		TextBox 330,175,70,21,.Tool3_TB
		TextBox 330,196,70,21,.Tool4_TB
		TextBox 330,217,70,21,.Tool5_TB

		'Rate
		Text 400,119,70,14,"&Rate[A/s]",.Rate_TB,2
		TextBox 400,133,70,21,.Rate1_TB
		TextBox 400,154,70,21,.Rate2_TB
		TextBox 400,175,70,21,.Rate3_TB
		TextBox 400,196,70,21,.Rate4_TB
		TextBox 400,217,70,21,.Rate5_TB

		'Load/Save
		'Material 1
		PushButton 10,133,40,21,"L1",.L1_PB
		PushButton 50,133,40,21,"S1",.S1_PB
		'Material 2
		PushButton 10,154,40,21,"L2",.L2_PB
		PushButton 50,154,40,21,"S2",.S2_PB
		'Material 3
		PushButton 10,175,40,21,"L3",.L3_PB
		PushButton 50,175,40,21,"S3",.S3_PB
		'Material 4
		PushButton 10,196,40,21,"L4",.L4_PB
		PushButton 50,196,40,21,"S4",.S4_PB
		'Material 5
		PushButton 10,217,40,21,"L5",.L5_PB
		PushButton 50,217,40,21,"S5",.S5_PB
		'Output to...
		GroupBox 10,287,150,42,"Output to ...",.GroupBox4
		PushButton 20,301,60,21,"C&SV",.CSV_PB
		PushButton 90,301,60,21,"Re&port",.Report_PB
		'Calculate
		PushButton 500,308,90,21,"&Calculate",.Calc_PB
		OKButton 610,308,90,21,.OK

		'Other
		GroupBox 480,119,110,182,"Thickness[nm]",.GroupBox3
		TextBox 490,133,90,21,.Thickness1_TB
		TextBox 490,154,90,21,.Thickness2_TB
		TextBox 490,175,90,21,.Thickness3_TB
		TextBox 490,196,90,21,.Thickness4_TB
		TextBox 490,217,90,21,.Thickness5_TB
		TextBox 490,245,70,21,.ThicknessN_TB
		TextBox 490,273,70,21,.ThicknessU_TB
		GroupBox 600,119,110,182,"Tact Time[min]",.GroupBox1
		TextBox 610,133,90,21,.TactTime1_TB
		TextBox 610,154,90,21,.TactTime2_TB
		TextBox 610,175,90,21,.TactTime3_TB
		TextBox 610,196,90,21,.TactTime4_TB
		TextBox 610,217,90,21,.TactTime5_TB
		TextBox 610,245,70,21,.TactTime_TB
		TextBox 610,273,30,21,.TactTimeH_TB
		TextBox 650,273,30,21,.TactTimeM_TB
		Text 430,266,40,14,"Total",.Text14,1
		Text 640,280,10,14,"h",.Text15
		Text 680,280,20,14,"m",.Text16
		Text 680,252,20,14,"m",.Text17
		Text 560,252,20,14,"nm",.Text18
		Text 560,280,20,14,"um",.Text19
		Text 10,112,40,14,"Load",.Text11,2
		Text 50,105,40,28,"Save as ...",.Text12,2
		Text 100,245,110,14,"* : Description",.Text4
	End Dialog
	Dim dlg As UserDialog

	Dialog dlg
Quit:
    Exit Sub
End Sub

Function DlgMachineFunc%(DlgItem$, Action%, SuppValue%)
    Select Case Action%
    Case 1 ' Dialog box initialization
		'Load of initialization file
		ReadInit
		'Calculation of thickness
		CalcThickness
    Case 2 ' Value changing or button pressed
    	'----- Load of all parameters -----
    	If DlgItem$ = "Load_PB" Then
			LoadParam
            DlgMachineFunc% = True 'do not exit the dialog

    	'----- Output of all paramters -----
    	ElseIf DlgItem$ = "Save_PB" Then
			SaveParam
            DlgMachineFunc% = True 'do not exit the dialog

    	'----- Output to CSV file -----
		ElseIf DlgItem$ = "CSV_PB" Then
            OutputCSV
            DlgMachineFunc% = True 'do not exit the dialog

    	'----- Output to Report -----
		ElseIf DlgItem$ = "Report_PB" Then
			OutputReport
            DlgMachineFunc% = True 'do not exit the dialog

    	'----- Load of machine data -----
		ElseIf DlgItem$ = "LoadMch_PB" Then
			LoadMachine
            DlgMachineFunc% = True 'do not exit the dialog

    	'----- Output of machine data -----
		ElseIf DlgItem$ = "SaveMch_PB" Then
			SaveMachine
            DlgMachineFunc% = True 'do not exit the dialog

    	'----- Load of material data -----
		ElseIf 	DlgItem$ = "L1_PB" Or DlgItem$ = "L2_PB" Or DlgItem$ = "L3_PB" Or _
				DlgItem$ = "L4_PB" Or DlgItem$ = "L5_PB" Then
			LoadMtl(DlgItem)
            DlgMachineFunc% = True 'do not exit the dialog

    	'----- Output of material data -----
		ElseIf 	DlgItem$ = "S1_PB" Or DlgItem$ = "S2_PB" Or DlgItem$ = "S3_PB" Or _
				DlgItem$ = "S4_PB" Or DlgItem$ = "S5_PB" Then
			SaveMtl(DlgItem)
            DlgMachineFunc% = True 'do not exit the dialog

    	'----- Calculation of production tact time -----
    	ElseIf DlgItem$ = "Calc_PB" Then
    		If DlgMachineErr = True  Then
				'Update of machine data
    			UpdateMD
    			'Calculation of thickness
				CalcThickness
				'Calculation of production tact time
				CalcTact
            End If
       	    DlgMachineFunc% = True 'do not exit the dialog

    	'----- Finish -----
        ElseIf DlgItem$ = "OK" Then
			'Write initialization file
			WriteInit
            DlgMachineFunc% = False 'exit the dialog
        End If
    Case 4 ' Focus changed
        Debug.Print "DlgFocus=""";DlgFocus();""""
    Case 6 ' Function key
        If SuppValue And &H100 Then Debug.Print "Shift-";
        If SuppValue And &H200 Then Debug.Print "Ctrl-";
        If SuppValue And &H400 Then Debug.Print "Alt-";
        Debug.Print "F" & (SuppValue And &HFF)
    End Select
End Function

'Error check
Function DlgMachineErr As Boolean
	Dim i As Integer
	Dim ss As String, sss As String

	DlgMachineErr = True
	If DTCheck("Pump_TB") < 0 Then
		MsgBox "Input 0 or more to 'Pumping' "
		DlgMachineErr = False
		DlgFocus "Pump_TB"
	End If
	If DTCheck("Com_TB") < 0 Then
		MsgBox "Input 0 or more to 'Comunication(1 layer)'"
		DlgMachineErr = False
		DlgFocus "Com_TB"
	End If
	For i=1 To MTLS Step 1
		ss = "Sym" & i & "_TB"
		If DlgText(ss) <> "" Then
			ss = "Heat" & i & "_TB"
			If DTCheck(ss) < 0 Then
				MsgBox "Input 0 or more to material" & i & "'s 'Pre-melt' "
				DlgMachineErr = False
				DlgFocus ss
			End If
			ss = "Rate" & i & "_TB"
			If DTCheck(ss) < 0 Then
				MsgBox "Input 0 or more to material" & i & "'s 'Rate' "
				DlgMachineErr = False
				DlgFocus ss
			End If
			ss = "Tool" & i & "_TB"
			If DTCheck(ss) < 0 Then
				MsgBox "Input 0 or more to material" & i & "'s 'Tooling' "
				DlgMachineErr = False
				DlgFocus ss
			End If
		End If
	Next i
End Function

'Calculation of thin film thickness
Sub CalcThickness
	Dim thick As Single
	Dim th(MTLS) As Single
	Dim l As Integer
	Dim i As Integer
	Dim ss As String

	'Calculation of each material
	For i=1 To MTLS Step 1
		th(i)=0
	Next i

	For l=1 To nLay Step 1
		For i=1 To MTLS Step 1
			If qt(l) = MD.M(i).sym  Then
				th(i) = th(i) + q(l)
			End If
		Next i
	Next l

	For i=1 To MTLS Step 1
		ss = "Thickness" & i & "_TB"
		DlgText(ss,Format(CStr(th(i)),"0.0"))
		MD.M(i).thick = th(i)
	Next i

	'Calculation of total thickness
	thick=0
	For l=1 To nLay Step 1
		thick = thick + q(l)
	Next l
	DlgText("ThicknessN_TB", Format(CStr(thick),"0.0"))
	DlgText("ThicknessU_TB", Format(CStr(thick/1000), "0.000"))
	MD.thick = thick
End Sub

'Calculation of production tact time
Function CalcTact As Boolean
	Dim tact As Single, tactH As Integer , tactM As Integer
	Dim tac(MTLS) As Single '[min]
	Dim l As Integer, i As Integer
	Dim ss As String

	'Initialization
	CalcTact = True
	tact = 0
	MD.tact = 0
	For i=1 To MTLS Step 1
		tac(i)=0
	Next i

	'Calculation of production tact time for each material
	For l=1 To nLay Step 1
		For i=1 To MTLS Step 1
			If qt(l) = MD.M(i).sym Then
				If MD.M(i).rate > 0 And MD.M(i).tool > 0 Then
					Debug.Print i & " " & MD.M(i).rate & " " & MD.M(i).tool
					tac(i) = tac(i) + q(l)/(MD.M(i).rate * 0.1 * MD.M(i).tool) + MD.M(i).pre_heat
				Else
					tac(i) = 0
				End If
				Exit For
			ElseIf i=MTLS Then
				MsgBox "Symbol '" & qt(l) & "' is not inputted."
				CalcTact = False
				Exit For
			End If
		Next i
		If CalcTact = False Then
			Exit Function
		End If
	Next l
	For i=1 To MTLS Step 1
		MD.M(i).tact = tac(i)/60 'sec->min
	Next i

	'Calculation of total production tact time
	For i=1 To MTLS Step 1
		MD.tact = MD.tact + MD.M(i).tact
	Next i
	MD.tact = MD.tact + MD.pump + MD.pre_pro + MD.com*(nLay-1) + MD.post_pro

	'Set to dialog box
	For i=1 To MTLS Step 1
		ss = "TactTime" & i & "_TB"
		DlgText(ss, Format(CStr(MD.M(i).tact),"#.0"))
	Next i
	DlgText("TactTime_TB", Format(CStr(MD.tact),"#.0"))
	tactH = Int(MD.tact/60)
	tactM = MD.tact - tactH*60
	DlgText("TactTimeH_TB", Format(CStr(tactH),"0"))
	DlgText("TactTimeM_TB", Format(CStr(tactM),"0"))
End Function

'Update of Machine data structure
Sub UpdateMD
 	Dim i As Integer
 	Dim ss As String

	'Get machine data structure
	MD.pump = DTCheck("Pump_TB")
	MD.pre_pro = DTCheck("Preprocess_TB")
	MD.com = DTCheck("Com_TB")
	MD.post_pro = DTCheck("Postprocess_TB")
	'MD.vent = DTCheck("Vent_TB")

	For i=1 To MTLS Step 1
		ss = "Mtl" & i & "_TB"
		MD.M(i).mtl = DlgText(ss)
		ss = "Heat" & i & "_TB"
		MD.M(i).pre_heat = DTCheck(ss)
		ss = "Rate" & i & "_TB"
		MD.M(i).rate = DTCheck(ss)
		ss = "Sym" & i & "_TB"
		MD.M(i).sym = DlgText(ss)
		ss = "Tool" & i & "_TB"
		MD.M(i).tool = DTCheck(ss)
	Next i
End Sub

'Output to CSV file
Sub OutputCSV
	Dim FName As String, strLight As String, strDeg As String
	Dim FNo As Integer, Light As Integer, i As Integer
	Dim tactH As Integer, tactM As Integer

   	FName=GetFilePath$(,"csv",,"Assign the CSV file",1)
   	If FName="" Then
		Exit Sub
   	End If
	FNo = FreeFile
    Open FName For Output As FNo

	Write #FNo, "General"
    Write #FNo, "Punpimg[min]", MD.pump
    Write #FNo, "Pre-processing[min]", MD.pre_pro
    Write #FNo, "Comunication[min]", MD.com
    Write #FNo, "Post-processing[min]", MD.post_pro
	Write #FNo, ""
	Write #FNo, "Material"
	Write #FNo, "", "Symbol", "Material", "Rate[A/s]", "Tooling", "Thickness[nm]", "Tact time[min]"
	For i=1 To MTLS Step 1
		Write #FNo, i, MD.M(i).sym, MD.M(i).mtl, MD.M(i).rate, MD.M(i).tool, Format(MD.M(i).thick,"0.0"), Format(MD.M(i).tact,"0.0")
	Next i
	tactH = Int(MD.tact/60)
	tactM = Round(MD.tact - tactH*60)
	Write #FNo, ""
	Write #FNo, "Total"
	Write #FNo, "Thickness[nm]", Format(MD.thick,"0.0"), "Thickness[um]", Format(MD.thick/1000,"0.0")
	Write #FNo, "Tact time[min]", Format(MD.tact,"0.0"), "Tact time[h:m]", tactH & ":" & tactM
	Close FNo
End Sub

'Output to Report
Sub OutputReport
	Dim s As String
	Dim k

	s = "<<Name Arial>><<Size 18>><<Align 1>><<Bold 1>>" & Chr$(13) & Chr$(10)
	s = s & "TOKAI Optical Co., LTD." & Chr$(13) & Chr$(10)
	s = s & "<<Name Lucida Sans Typewriter>><<Size 10>><<Bold 0>>" & Chr$(13) & Chr$(10)
	s = s & "<<Review>>" & Chr$(13) & Chr$(10)
	s = s & Chr$(13) & Chr$(10)
	'Production tact time
	s = s & "<<size 12>><<bold 1>>"
	s = s & "Tact time=" & Format(MD.tact,"#.0") & "[min] (" & _
			Format(MD.tact/60,"#.0") & "[hr])     "
	'Total thickness
	s = s & "Total thickness=" & Format(MD.thick, "#.0") & "[nm]" & Chr$(13) & Chr$(10)
	s = s & "<<FSPlot>>" & Chr$(13) & Chr$(10)
	Template = s

	k = Macro("ShowReport;")
End Sub

'Load all parameter file
Sub LoadParam
	Dim FName As String, ss As String
	Dim FNo As Integer, i As Integer

	'Load all parameter file
   	FName = GetFilePath$(,FEND,,"Load all parameters",1)
	If FName = "" Then
		Exit Sub
	End If
	FNo = FreeFile
	Open FName For Input As FNo
    Input #FNo, MD.pump, MD.pre_pro, MD.com, MD.post_pro
	For i=1 To MTLS Step 1
		Input #FNo, MD.M(i).mtl, MD.M(i).pre_heat, MD.M(i).rate, MD.M(i).sym, MD.M(i).tool
	Next i
	Close FNo

	'Set to dialog box
	DlgText("Pump_TB", DTCheck2(CStr(MD.pump)))
	DlgText("Preprocess_TB", DTCheck2(CStr(MD.pre_pro)))
	DlgText("Com_TB", DTCheck2(CStr(MD.com)))
	DlgText("Postprocess_TB", DTCheck2(CStr(MD.post_pro)))
	For i=1 To MTLS Step 1
		ss = "Mtl" & i & "_TB"
		DlgText(ss, CStr(MD.M(i).mtl))
		ss = "Heat" & i & "_TB"
		DlgText(ss, DTCheck2(CStr(MD.M(i).pre_heat)))
		ss = "Rate" & i & "_TB"
		DlgText(ss, DTCheck2(CStr(MD.M(i).rate)))
		ss = "Sym" & i & "_TB"
		DlgText(ss, CStr(MD.M(i).sym))
		ss = "Tool" & i & "_TB"
		DlgText(ss, DTCheck2(CStr(MD.M(i).tool)))
	Next i
End Sub

'Output ot all parameter file
Sub SaveParam
	Dim FName As String, ss As String
	Dim FNo As Integer, i As Integer

	'Get parameters from dialog box
	MD.pump = DlgText("Pump_TB")
	MD.pre_pro = DlgText("Preprocess_TB")
	MD.com = DlgText("Com_TB")
	MD.post_pro = DlgText("Postprocess_TB")
	For i=1 To MTLS Step 1
		ss = "Mtl" & i & "_TB"
		MD.M(i).mtl = DlgText(ss)
		ss = "Heat" & i & "_TB"
		MD.M(i).pre_heat = DTCheck(ss)
		ss = "Rate" & i & "_TB"
		MD.M(i).rate = DTCheck(ss)
		ss = "Sym" & i & "_TB"
		MD.M(i).sym = DlgText(ss)
		ss = "Tool" & i & "_TB"
		MD.M(i).tool = DTCheck(ss)
	Next i

	'Write all parameters to a file
   	FName=GetFilePath$(,FEND,,"Write all parameters to a file",1)
	If FName = "" Then
		Exit Sub
	End If
	FNo = FreeFile
   	Open FName For Output As FNo
    Write #FNo, MD.pump, MD.pre_pro, MD.com, MD.post_pro
    For i=1 To MTLS Step 1
		Write #FNo, MD.M(i).mtl, MD.M(i).pre_heat, MD.M(i).rate, MD.M(i).sym, MD.M(i).tool
    Next i
	Close FNo
End Sub

'Load of machine file
Sub LoadMachine
	Dim FName As String, ss As String
	Dim FNo As Integer, i As Integer

	'Load of machine file
   	FName = GetFilePath$(,FEND_MCH,,"Load of machine data",1)
	If FName = "" Then
		Exit Sub
	End If
	FNo = FreeFile
	Open FName For Input As FNo
    Input #FNo, MD.pump, MD.pre_pro, MD.com, MD.post_pro
	Close FNo

	'Set to dialog box
	DlgText("Pump_TB", DTCheck2(CStr(MD.pump)))
	DlgText("Preprocess_TB", DTCheck2(CStr(MD.pre_pro)))
	DlgText("Com_TB", DTCheck2(CStr(MD.com)))
	DlgText("Postprocess_TB", DTCheck2(CStr(MD.post_pro)))
End Sub

'Output to machine file
Sub SaveMachine
	Dim FName As String, ss As String
	Dim FNo As Integer, i As Integer

	'Get parameters from dialog box
	MD.pump = DlgText("Pump_TB")
	MD.pre_pro = DlgText("Preprocess_TB")
	MD.com = DlgText("Com_TB")
	MD.post_pro = DlgText("Postprocess_TB")

	'Output to machine file
   	FName=GetFilePath$(,FEND_MCH,,"Output machine parameters to a file",1)
	If FName = "" Then
		Exit Sub
	End If
	FNo = FreeFile
   	Open FName For Output As FNo
    Write #FNo, MD.pump, MD.pre_pro, MD.com, MD.post_pro
	Close FNo
End Sub

'Load of material file
Sub LoadMtl(PB As String)
	Dim FName As String, ss As String
	Dim FNo As Integer, no As Integer, i As Integer

	i=1
	Do
		If PB="L" & i & "_PB" Then
			Exit Do
		End If
		i = i+1
	Loop
	no=i

	'Load of material file
   	FName = GetFilePath$(,FEND_MTL,,"Load of material file",1)
	If FName = "" Then
		Exit Sub
	End If
	FNo = FreeFile
	Open FName For Input As FNo
	Input #FNo, MD.M(no).mtl, MD.M(no).pre_heat, MD.M(no).rate, MD.M(no).sym, MD.M(no).tool
	Close FNo

	'Set to dialog box
	ss = "Mtl" & no & "_TB"
	DlgText(ss, CStr(MD.M(no).mtl))
	ss = "Heat" & no & "_TB"
	DlgText(ss, DTCheck2(CStr(MD.M(no).pre_heat)))
	ss = "Rate" & no & "_TB"
	DlgText(ss, DTCheck2(CStr(MD.M(no).rate)))
	ss = "Sym" & no & "_TB"
	DlgText(ss, CStr(MD.M(no).sym))
	ss = "Tool" & no & "_TB"
	DlgText(ss, DTCheck2(CStr(MD.M(no).tool)))

End Sub

'Output to material file
Sub SaveMtl(PB As String)
	Dim FName As String, ss As String
	Dim FNo As Integer, no As Integer, i As Integer

	i=1
	Do
		If PB="S" & i & "_PB" Then
			Exit Do
		End If
		i = i+1
	Loop
	no=i

	'Get parameters from dialog box
	ss = "Mtl" & no & "_TB"
	MD.M(no).mtl = DlgText(ss)
	ss = "Heat" & no & "_TB"
	MD.M(no).pre_heat = DlgText(ss)
	ss = "Rate" & no & "_TB"
	MD.M(no).rate = DlgText(ss)
	ss = "Sym" & no & "_TB"
	MD.M(no).sym = DlgText(ss)
	ss = "Tool" & no & "_TB"
	MD.M(no).tool = DlgText(ss)

	'Output to material file
   	FName=GetFilePath$(MD.M(no).mtl, FEND_MTL, ,"Output material data to a file",1)
	If FName = "" Then
		Exit Sub
	End If
	FNo = FreeFile
   	Open FName For Output As FNo
   	Write #FNo, MD.M(no).mtl, MD.M(no).pre_heat, MD.M(no).rate, MD.M(no).sym, MD.M(no).tool
	Close FNo

End Sub

'Load of initialization file
Sub ReadInit
	Dim FName As String, ss As String
	Dim FNo As Integer, i As Integer

	'Load of initialization file
   	FName= MacroDir$() & FNAME_INI
	FNo = FreeFile
	Open FName For Input As FNo
    Input #FNo, MD.pump, MD.pre_pro, MD.com, MD.post_pro
	For i=1 To MTLS Step 1
   		Input #FNo, MD.M(i).mtl, MD.M(i).pre_heat, MD.M(i).rate, MD.M(i).sym, MD.M(i).tool
	Next i
	Close FNo

	'Set to dialog box
	DlgText("Pump_TB", DTCheck2(MD.pump))
	DlgText("Preprocess_TB", DTCheck2(MD.pre_pro))
	DlgText("Com_TB", DTCheck2(MD.com))
	DlgText("Postprocess_TB", DTCheck2(MD.post_pro))
	'DlgText("Vent_TB", CStr(MD.vent))
	For i=1 To MTLS Step 1
		ss = "Mtl" & i & "_TB"
		DlgText(ss, CStr(MD.M(i).mtl))
		ss = "Heat" & i & "_TB"
		DlgText(ss, DTCheck2(MD.M(i).pre_heat))
		ss = "Rate" & i & "_TB"
		DlgText(ss, DTCheck2(MD.M(i).rate))
		ss = "Sym" & i & "_TB"
		DlgText(ss, CStr(MD.M(i).sym))
		ss = "Tool" & i & "_TB"
		DlgText(ss, DTCheck2(MD.M(i).tool))
	Next i
End Sub

'Output to initialization file
Sub WriteInit
	Dim FName As String, ss As String
	Dim FNo As Integer, i As Integer

	'Get paramters from dialog box
	MD.pump = DTCheck("Pump_TB")
	MD.pre_pro = DTCheck("Preprocess_TB")
	MD.com = DTCheck("Com_TB")
	MD.post_pro = DTCheck("Postprocess_TB")
	'MD.vent = DTCheck("Vent_TB")
	For i=1 To MTLS Step 1
		ss = "Mtl" & i & "_TB"
		MD.M(i).mtl = DlgText(ss)
		ss = "Heat" & i & "_TB"
		MD.M(i).pre_heat = DTCheck(ss)
		ss = "Rate" & i & "_TB"
		MD.M(i).rate = DTCheck(ss)
		ss = "Sym" & i & "_TB"
		MD.M(i).sym = DlgText(ss)
		ss = "Tool" & i & "_TB"
		MD.M(i).tool = DTCheck(ss)
	Next i

	'Output to initialing file
   	FName= MacroDir$() & FNAME_INI
	FNo = FreeFile
   	Open FName For Output As FNo
	Write #FNo, MD.pump, MD.pre_pro, MD.com, MD.post_pro
    For i=1 To MTLS Step 1
    	Write #FNo, MD.M(i).mtl, MD.M(i).pre_heat, MD.M(i).rate, MD.M(i).sym, MD.M(i).tool
    Next i
	Close FNo
End Sub

Function DTCheck(ss As String ) As Single
	If DlgText(ss)="" Then
		DTCheck=-1
	Else
		DTCheck = DlgText(ss)
	End If
End Function

Function DTCheck2(ss As Single ) As String
	If ss=-1 Then
		DTCheck2=""
	Else
		DTCheck2=CStr(ss)
	End If
End Function
